#include <unistd.h> 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gringo.h>

// ... in parser.c
extern void ParseInputFile(FILE *localfile)
;

// ... libgringo private internals
extern TObject *gringo_Windows;
extern int gringo_WindowsCount;


void gringosh_PrintStatus() {
  int i,j;
  fprintf(stderr, "GRINGOSH=1\n");
  for (i=0; i<gringo_WindowsCount; i++) {
    fprintf(stderr, "%s=\"%s\"\n", gringo_Windows[i].name, gringo_Windows[i].title );
    for (j=0; j < (gringo_Windows[i]).widgets_count; j++) {
      if (gringo_Windows[i].widgets[j].type != TYPE_LABEL) {
        fprintf(stderr, "%s=\"%s\"\n", gringo_Windows[i].widgets[j].name, gringo_Windows[i].widgets[j].title );
      }
    }
  }
}


void exit_from_gringosh(void) {
  gringo_Terminate(0);
}


int main(int argc, char* argv[])
 {
    
  // Vars
  int  opt_nostdin = 0;		// Use a file or stdin ?
  char *opt_inputfile = NULL;
 	// Input file name
  FILE *input_file;
		// Pointer to the input file	
  int i;			// Counters

  // Copyright
  printf("# GRINGO Shell - Shell to execute program written in GRINGO language\n");
  printf("# @1999 by Antonio GALLO <agx@linux.it>\n");
  printf("# Version 1.1.0\n");
  printf("# This is a GPL software part of Bad Penguin (www.badpenguin.org)\n\n");

  // Checking Parameters
  i=1;
  while (i<argc) {

    if ( 0 == strcmp( "-f", argv[i] ) ) {
      opt_nostdin = 1;
      i++;
      if (i<argc) {
        opt_inputfile = strdup( argv[i] );
      } else {
        fprintf(stderr, "GRINGOSH: You used -f options without a filename !\n\n" );
        exit(1);
      }
    }

    // Next
    i++;
  }


  // Doing COOL stuffs ...
  if ( opt_nostdin == 1 ) {
    input_file = fopen( opt_inputfile, "r" );
    if ( NULL == input_file ) {
      fprintf(stderr, "GRINGOSH: ATTENZIONE Inpossibile aprire il file %s !!\n\n", opt_inputfile );
      exit(1);
    }

  } else {
    input_file = stdin;
  }

  // Start
  gringo_Init( &argc, &argv );
  // Parse The Input File
  ParseInputFile( input_file );
  if ( opt_nostdin == 1 ) fclose( input_file );

  // Done
  gringo_Loop();  
  gringosh_PrintStatus();
  gringo_Quit();
  return 0;
}
